Imports System.Globalization

Public Class Form1
    ' Calculate the payments.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        ' Get the parameters.
        Dim balance As Decimal = Decimal.Parse(txtInitialBalance.Text, NumberStyles.Any)
        Dim interest_rate As Decimal = Decimal.Parse(txtInterestRate.Text.Replace("%", "")) / 100
        Dim payment_percent As Decimal = Decimal.Parse(txtPaymentPercent.Text.Replace("%", "")) / 100
        Dim min_payment As Decimal = Decimal.Parse(txtMinPayment.Text, NumberStyles.Any)
        interest_rate /= 12

        txtTotalPayments.Clear()
        Dim total_payments As Decimal = 0

        ' Display the initial balance.
        lvwPayments.Items.Clear()
        Dim new_item As ListViewItem = lvwPayments.Items.Add("0")
        new_item.SubItems.Add("")
        new_item.SubItems.Add("")
        new_item.SubItems.Add(balance.ToString("c"))

        ' Loop until balance == 0.
        Dim i As Integer = 1
        Do While (balance > 0)
            ' Calculate the payment.
            Dim payment As Decimal = balance * payment_percent
            If (payment < min_payment) Then payment = min_payment

            ' Calculate interest.
            Dim interest As Decimal = balance * interest_rate
            balance += interest

            ' See if we can pay off the balance.
            If (payment > balance) Then payment = balance
            total_payments += payment
            balance -= payment

            ' Display results.
            new_item = lvwPayments.Items.Add(i.ToString())
            new_item.SubItems.Add(payment.ToString("c"))
            new_item.SubItems.Add(interest.ToString("c"))
            new_item.SubItems.Add(balance.ToString("c"))

            ' Process the next month.
            i += 1
        Loop

        ' Display the total payments.
        txtTotalPayments.Text = total_payments.ToString("c")
    End Sub
End Class
